//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com mladen"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     Goldenrod
#property indicator_color2     DeepPink
#property indicator_color3     LimeGreen
#property indicator_color4     DeepPink
#property indicator_color5     LimeGreen
#property indicator_levelcolor DarkSlateGray
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     3
#property indicator_width5     3
#property indicator_minimum    -120
#property indicator_maximum    120

//
//
//
//
//

extern double AroonPeriod      = 25;
extern double T3Hot            = 1.0; 
extern bool   T3Original       = false; 
extern int    Filter           = 90;

extern string Alerts_Settings  = "Settings for alerts";
extern bool   alerts.On        = false;
extern bool   alerts.OnCurrent = false;
extern bool   alerts.Message   = true;
extern bool   alerts.Sound     = false;
extern bool   alerts.Email     = false;


//
//
//
//
//

double osc[];
double osclu[];
double oscld[];
double oscau[];
double oscad[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,osc);
   SetIndexBuffer(1,osclu);
   SetIndexBuffer(2,oscld);
   SetIndexBuffer(3,oscau); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,108);
   SetIndexBuffer(4,oscad); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,108);
   SetIndexBuffer(5,trend);
      SetLevelValue(0, Filter);
      SetLevelValue(1, 0);
      SetLevelValue(2,-Filter);
   
   IndicatorShortName("T3 Aroon oscillator ("+DoubleToStr(AroonPeriod,2)+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      double AroonUp = 100.0*(AroonPeriod-iHighest(NULL,0,MODE_HIGH,AroonPeriod,i)+i)/AroonPeriod;
      double AroonDn = 100.0*(AroonPeriod- iLowest(NULL,0,MODE_LOW ,AroonPeriod,i)+i)/AroonPeriod;
           if (AroonUp != AroonDn)
                 osc[i] = iT3(AroonUp-AroonDn,AroonPeriod,T3Hot,T3Original,i);
           else  osc[i] = iT3(0,              AroonPeriod,T3Hot,T3Original,i); 
           osclu[i] = EMPTY_VALUE;
           oscld[i] = EMPTY_VALUE;
           oscau[i] = EMPTY_VALUE;
           oscad[i] = EMPTY_VALUE;
           trend[i] = trend[i+1];
              if (osc[i] >  Filter)                     trend[i] =  1;
              if (osc[i] < -Filter)                     trend[i] = -1;
              if (osc[i] <  Filter && osc[i] > -Filter) trend[i] = 0;
              if (trend[i] == 1)
              {
                 osclu[i] = osc[i]; if (trend[i]!=trend[i+1]) oscau[i] = osc[i];
              }
              if (trend[i] == -1)
              {
                 oscld[i] = osc[i]; if (trend[i]!=trend[i+1]) oscad[i] = osc[i];
              }
   }
   
   //
   //
   //
   //
   //
   
   if (alerts.On)
   {
      if (alerts.OnCurrent)
            int forBar = 0;
      else      forBar = 1;
      
      //
      //
      //
      //
      //

      if (oscau[forBar]!= EMPTY_VALUE) doAlert("Aroon oscillator trend chaned to UP");
      if (oscad[forBar]!= EMPTY_VALUE) doAlert("Aroon oscillator trend chaned to DOWN");
   }      
   return(0);
}


//----------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Aroon oscillator - ",doWhat);
          if (alerts.Message) Alert(message);
          if (alerts.Email)   SendMail("Aroon oscillator",message);
          if (alerts.Sound)   PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}